#!/usr/bin/env bash

# colors...
LIGHT_GREEN='\033[1;32m'
LIGHT_RED='\033[1;31m'
NC='\033[0m' # No Color

BASE_URL="http://127.0.0.1:5984"
DB_NAME="univ_rennes1"
PRETTY_PRINT="python -m json.tool"

# Make sure the DB is deleted before we start
curl -X DELETE ${BASE_URL}/${DB_NAME} &> /dev/null


echo -e "${LIGHT_GREEN}Création d'une base de données appelée '${DB_NAME}'${NC}"
COMMAND="curl -X PUT ${BASE_URL}/${DB_NAME}"
echo -e "${LIGHT_RED}${COMMAND}${NC}"
read -n 1 -s
${COMMAND} 2> /dev/null | ${PRETTY_PRINT}
echo
read -n 1 -s


echo -e "${LIGHT_GREEN}Création de documents${NC}"
read -n 1 -s
UUID=173fce259fccf5959b44c448110126c0
COMMAND="curl -X PUT ${BASE_URL}/${DB_NAME}/${UUID} -d '{\"batiment\": \"12D\", \"salle\": 57, \"postes\": 20}'"
echo -e "${LIGHT_RED}${COMMAND}${NC}"
eval ${COMMAND} &> /dev/null

UUID=173fce259fccf5959b44c448110131c3
COMMAND="curl -X PUT ${BASE_URL}/${DB_NAME}/${UUID} -d '{\"batiment\": \"12D\", \"salle\": 58, \"postes\": 25}'"
echo -e "${LIGHT_RED}${COMMAND}${NC}"
eval ${COMMAND} &> /dev/null

UUID=173fce259fccf5959b44c44811012971
COMMAND="curl -X PUT ${BASE_URL}/${DB_NAME}/${UUID} -d '{\"batiment\": \"12D\", \"salle\": 59, \"postes\": 15}'"
echo -e "${LIGHT_RED}${COMMAND}${NC}"
eval ${COMMAND} &> /dev/null

UUID=173fce259fccf5959b44c44811013295
COMMAND="curl -X PUT ${BASE_URL}/${DB_NAME}/${UUID} -d '{\"batiment\": \"12D\", \"salle\": 60, \"postes\": 17}'"
echo -e "${LIGHT_RED}${COMMAND}${NC}"
eval ${COMMAND} &> /dev/null

UUID=173fce259fccf5959b44c44811013826
COMMAND="curl -X PUT ${BASE_URL}/${DB_NAME}/${UUID} -d '{\"batiment\": \"O\", \"salle\": 101, \"postes\": 17}'"
echo -e "${LIGHT_RED}${COMMAND}${NC}"
eval ${COMMAND} &> /dev/null

UUID=173fce259fccf5959b44c448110142f3
COMMAND="curl -X PUT ${BASE_URL}/${DB_NAME}/${UUID} -d '{\"batiment\": \"O\", \"salle\": 102, \"postes\": 14}'"
echo -e "${LIGHT_RED}${COMMAND}${NC}"
eval ${COMMAND} &> /dev/null

UUID=173fce259fccf5959b44c44811014aca
COMMAND="curl -X PUT ${BASE_URL}/${DB_NAME}/${UUID} -d '{\"batiment\": \"O\", \"salle\": 103, \"postes\": 26}'"
echo -e "${LIGHT_RED}${COMMAND}${NC}"
eval ${COMMAND} &> /dev/null

UUID=173fce259fccf5959b44c44811014b80
COMMAND="curl -X PUT ${BASE_URL}/${DB_NAME}/${UUID} -d '{\"batiment\": \"O\", \"salle\": 104, \"postes\": 21}'"
echo -e "${LIGHT_RED}${COMMAND}${NC}"
eval ${COMMAND} &> /dev/null
echo
read -n 1 -s


echo -e "${LIGHT_GREEN}Création du design document pour accueillir les vues${NC}"
DDOC=salles
COMMAND="curl -X PUT ${BASE_URL}/${DB_NAME}/_design/${DDOC} -d @salles.json"
echo -e "${LIGHT_RED}${COMMAND}${NC}"
echo -e "${LIGHT_RED}fichier salles.json..."
cat salles.json
echo -e -n "${NC}"
read -n 1 -s
eval ${COMMAND}
echo
read -n 1 -s


VIEW=par_postes
echo -e "${LIGHT_GREEN}Interrogation de la vue '${VIEW}'${NC}"
jq .views.${VIEW} salles.json
COMMAND="curl -X GET ${BASE_URL}/${DB_NAME}/_design/${DDOC}/_view/${VIEW}"
echo -e "${LIGHT_RED}${COMMAND}${NC}"
read -n 1 -s
eval ${COMMAND}
echo
read -n 1 -s


VIEW=par_batiment
echo -e "${LIGHT_GREEN}Interrogation de la vue '${VIEW}'${NC}"
jq .views.${VIEW} salles.json
COMMAND="curl -X GET ${BASE_URL}/${DB_NAME}/_design/${DDOC}/_view/${VIEW}"
echo -e "${LIGHT_RED}${COMMAND}${NC}"
read -n 1 -s
eval ${COMMAND}
echo
read -n 1 -s


VIEW=par_batiment
echo -e "${LIGHT_GREEN}Interrogation de la vue '${VIEW}', avec filtrage sur la sortie${NC}"
jq .views.${VIEW} salles.json
COMMAND="curl -X GET '${BASE_URL}/${DB_NAME}/_design/${DDOC}/_view/${VIEW}?key=\"12D\"'"
echo -e "${LIGHT_RED}${COMMAND}${NC}"
read -n 1 -s
eval ${COMMAND}
echo
read -n 1 -s


VIEW=total_postes
echo -e "${LIGHT_GREEN}Interrogation de la vue '${VIEW}'${NC}"
jq .views.${VIEW} salles.json
COMMAND="curl -X GET ${BASE_URL}/${DB_NAME}/_design/${DDOC}/_view/${VIEW}"
echo -e "${LIGHT_RED}${COMMAND}${NC}"
read -n 1 -s
eval ${COMMAND}
echo
read -n 1 -s


VIEW=total_postes
echo -e "${LIGHT_GREEN}Interrogation de la vue '${VIEW}', avec filtrage sur la sortie${NC}"
jq .views.${VIEW} salles.json
COMMAND="curl -X GET '${BASE_URL}/${DB_NAME}/_design/${DDOC}/_view/${VIEW}?key=\"12D\"'"
echo -e "${LIGHT_RED}${COMMAND}${NC}"
read -n 1 -s
eval ${COMMAND}
echo
read -n 1 -s

