#!/usr/bin/env bash

# colors...
LIGHT_GREEN='\033[1;32m'
LIGHT_RED='\033[1;31m'
NC='\033[0m' # No Color

BASE_URL="http://127.0.0.1:5984"
DB_NAME="univ_rennes1"
PRETTY_PRINT="python -m json.tool"

# Make sure the DB is deleted before we start
curl -X DELETE ${BASE_URL}/${DB_NAME} &> /dev/null


echo -e "${LIGHT_GREEN}Création d'une base de données appelée '${DB_NAME}'${NC}"
COMMAND="curl -X PUT ${BASE_URL}/${DB_NAME}"
echo -e "${LIGHT_RED}${COMMAND}${NC}"
read -n 1 -s
${COMMAND} 2> /dev/null | ${PRETTY_PRINT}


UUID=173fce259fccf5959b44c448110126c0
echo -e "${LIGHT_GREEN}Création d'un document ${UUID}${NC}"
COMMAND="curl -X PUT ${BASE_URL}/${DB_NAME}/${UUID} -d @istic.json"
echo -e "${LIGHT_RED}${COMMAND}${NC}"
echo -e "${LIGHT_RED}fichier istic.json..."
cat istic.json
echo -e -n "${NC}"
read -n 1 -s
eval ${COMMAND} 2> /dev/null | ${PRETTY_PRINT}


COMMAND="curl -X GET ${BASE_URL}/${DB_NAME}/${UUID}"
REV=$(eval ${COMMAND} 2> /dev/null | jq -r ._rev)
IMAGE_FILE=istic.jpg

echo -e "${LIGHT_GREEN}Ajout d'une piece jointe au document ${UUID}${NC}"
COMMAND="curl -X PUT ${BASE_URL}/${DB_NAME}/${UUID}/${IMAGE_FILE}?rev=${REV} --data-binary @${IMAGE_FILE} -H 'Content-Type: image/jpg'"
echo -e "${LIGHT_RED}${COMMAND}${NC}"
read -n 1 -s
eval ${COMMAND} 2> /dev/null | ${PRETTY_PRINT}


